/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ScormSessionDataAccess
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * ScormSessionテーブルへのアクセスクラス。
 * @author T.Nishiki
 */
public final class ScormSessionDataAccess extends ScormDataAccess {
	/**
	 * テーブル名。
	 */
	public static final String TABLE_NAME = "ScormSession";

	/**
	 * テーブル・列名：ユーザID。
	 */
	public static final String USERID = "UserID";

	/**
	 * テーブル・列名：LOID。
	 */
	public static final String LOID = "LOID";

	/**
	 * テーブル・列名：学習セッション回数。
	 */
	public static final String STUDY_SESSION_COUNT = "StudySessionCount";

	/**
	 * テーブル・列名：セッションID。
	 */
	public static final String SESSIONID = "SessionID";

	/**
	 * コンストラクタ
	 **/
	public ScormSessionDataAccess() {
		super( TABLE_NAME );
	}

	/**
	 * 指定したユーザ、教材から最終学習の学習セッション回数を取得します。<br>
	 * 渡されたユーザID、LOIDを条件にして、最大となる学習セッション回数を取得する
	 * レコードを取得します。もしレコードが存在しない場合、０を戻します。
	 * @param userID ユーザID。
	 * @param loID 教材のLOID。
	 * @param dataAccess データアクセスクラス・オブジェクト。
	 * @return 最終学習の学習セッション回数。
	 * @throws LOException データベースアクセスに失敗した場合。
	 */
	public static int getLastStudySessionCount(
		String userID,
		String loID,
		DataAccess dataAccess)
		throws LOException {

		// メソッド開始ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"HEAD getLastStudySessionCount("
				+ userID + "," + loID + "," + dataAccess + ")",
			DebugLog.ROW);
		// 学習セッション回数（このメソッドの戻り値）
		int studySessionCount = 0;
		// 結果セット
		ResultSet resultSet = null;
		// 成功フラグ（成功ならばtrue）
		boolean successFlag = false;
		try {
			String query = null;
			query = "select max(" +  STUDY_SESSION_COUNT + ")"
				+ " as lastSession"
				+ " from " + TABLE_NAME
				+ " where userid='" + userID + "'"
				+ " and loid='" + loID + "'";

			resultSet = dataAccess.executeQuery(query);
			if (resultSet.next()) {
				studySessionCount = resultSet.getInt("lastSession");
			}
			// tryブロック最後まで到達した場合、成功とする。
			successFlag = true;
		}
		catch (SQLException e) {
			DebugLog.write(
				ScormSessionDataAccess.class, e, DebugLog.HIGHT);
			throw new LOException(e.getMessage());
		}
		finally {
			// 結果セットのクローズ
			// 例外が発生した場合、それまで例外発生していなければ、スロー
			if (resultSet != null ) {
				try {
					resultSet.close();
				}
				catch (SQLException e) {
					if ( successFlag == true ) {
						DebugLog.write(
							ScormSessionDataAccess.class, e, DebugLog.HIGHT);
						throw new LOException(e.getMessage());
					}
				}
			}
		}

		// メソッド終了ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"TAIL getLastStudySessionCount("
				+ userID + "," + loID + "," + dataAccess + ")"
				+ " return " + studySessionCount,
			DebugLog.ROW);
		return studySessionCount;
	}



	/**
	 * ScormSessionテーブルへの書込みを実行します。<br>
	 * &lt;learnsession&gt;要素ごとに呼び出され、レコードを追加します。
	 *
	 * @param dataAccess データアクセスクラス。
	 * @param endLearnData 学習終了情報。
	 * @throws LOException データベースへの書込に失敗した場合。
	 */
	public static void insert(
		DataAccess dataAccess,
		ScormLoEndLearnData endLearnData)
		throws LOException {
		////////////////////////////////////////////////////////////////////////
		// メソッド開始ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"HEAD insert(dataAccess,endLearnData)",
			DebugLog.ROW);

		try {
			////////////////////////////////////////////////////////////////////
			// 各カラムの値を取得
			//==================================================================
			// カラムと値のマップ
			ScormColumnInfo[] columnInfos =
				makeColumnInfos(endLearnData);
			////////////////////////////////////////////////////////////////////
			// SQL文の生成
			String query =
				ScormLoUtil.makeInsertQuery(TABLE_NAME, columnInfos);
			////////////////////////////////////////////////////////////////////
			// SQL文の実行
			dataAccess.execute(query.toString());
		}
		catch (LOException e) {
			throw e;
		}
		catch (SQLException e) {
			DebugLog.write(
				ScormInteractionDataAccess.class, e, DebugLog.HIGHT);
			throw new LOException(e.getMessage());
		}
		////////////////////////////////////////////////////////////////////////
		// メソッド終了ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"TAIL insert(dataAccess,endLearnData)",
			DebugLog.ROW);
	}

	/**
	 * ScormSessionテーブルのカラム情報配列を生成します。<br>
	 * @param endLearnData 学習終了情報。
	 * @return ScormSessionテーブルのカラム情報配列。
	 * @throws LOException ノードからのデータ取得失敗した場合。
	 */
	private static ScormColumnInfo[] makeColumnInfos(
		ScormLoEndLearnData endLearnData)
		throws LOException {

		////////////////////////////////////////////////////////////////////////
		// メソッド開始ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"HEAD makeColumnInfos(endLearnData)",
			DebugLog.ROW);

		// このメソッドの戻り値
		ScormColumnInfo[] columnInfos = null;
		// 配列生成用リスト
		List columnInfoList = new ArrayList();
		////////////////////////////////////////////////////////////////////////
		// endLearnDataより取得できるデータをカラムとして設定
		//======================================================================
		// ユーザID
		String userID = endLearnData.getUserID();
		ScormColumnInfo userIDColumn = new ScormColumnInfo(
			USERID, userID,
			ScormColumnInfo.COLUMN_TYPE_STRING, 0, 0);
		columnInfoList.add(userIDColumn);
		// LOID
		String loID = endLearnData.getLoID();
		ScormColumnInfo loIDColumn = new ScormColumnInfo(
			LOID, loID,
			ScormColumnInfo.COLUMN_TYPE_STRING, 0, 0);
		columnInfoList.add(loIDColumn);
		// 学習セッション回数
		int studySessionCount = endLearnData.getStudySession();
		ScormColumnInfo studySessionCountColumn = new ScormColumnInfo(
			STUDY_SESSION_COUNT, Integer.toString(studySessionCount),
			ScormColumnInfo.COLUMN_TYPE_NUMBER, 0, 0);
		columnInfoList.add(studySessionCountColumn);
		// セッションID
		int sessionID = endLearnData.getLoginSession();
		ScormColumnInfo sessionIDColumn = new ScormColumnInfo(
			SESSIONID, Integer.toString(sessionID),
			ScormColumnInfo.COLUMN_TYPE_STRING, 0, 0);
		columnInfoList.add(sessionIDColumn);
		////////////////////////////////////////////////////////////////////////
		// リストを配列に変換
		columnInfos = new ScormColumnInfo[ columnInfoList.size() ];
		columnInfoList.toArray(columnInfos);

		////////////////////////////////////////////////////////////////////////
		// メソッド終了ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"TAIL makeColumnInfos(endLearnData)"
				+ " return " + columnInfos,
			DebugLog.ROW);
		return columnInfos;
	}

	/**
	 * 指定されたユーザ、教材の組み合わせのログを削除します。
	 * @param dataAccess データアクセス・オブジェクト。
	 * @param userID 削除対象のユーザID。
	 * @param loID 削除対象の教材のLOID。
	 * @throws LOException データベースアクセス中に例外が発生した場合。
	 */
	public static void delete(
		DataAccess dataAccess, String userID, String loID)
		throws LOException {

		// メソッド開始ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"HEAD delete(" + dataAccess + "," + userID + "," + loID + ")",
			DebugLog.ROW);
		try {
			// WHERE句の生成
			StringBuffer queryWhere = new StringBuffer();
			if (loID != null) {
				queryWhere.append(" and " + LOID + "='" + loID + "'" );
			}
			if (userID != null) {
				queryWhere.append(" and " + USERID + "='" + userID + "'" );
			}
			// 削除クエリの生成
			StringBuffer query = new StringBuffer();
			query.append("delete from " + TABLE_NAME );
			if (queryWhere.length() > 0) {
				query.append(" where " + queryWhere.substring(5) );
			}
			// 削除クエリの実行
			String queryString = query.toString();
			DebugLog.write( ScormAttemptDataAccess.class,
				queryString, DebugLog.MID);
			dataAccess.execute(queryString);
		}
		catch (SQLException e) {
			DebugLog.write(ScormAttemptDataAccess.class,
				e, DebugLog.HIGHT);
		}
		// メソッド終了ログ
		DebugLog.write(
			ScormSessionDataAccess.class,
			"TAIL delete(" + dataAccess + "," + userID + "," + loID + ")",
			DebugLog.ROW);
	}
}
